<?php
/*
 * The Outputting function, Template tag and Shortcode for the slick slider.
 */

/*
 * Template Tag
 */
function wp_slick_slider( $slider , $echo = true ){

    global $post , $wpss_options;

    $timthumbsrc = WPSS_HTTP_PATH . 'includes/timthumb/timthumb.php';

    $data = get_option( 'wpss_' . $slider . '_options' );
    
    //Image Measurement Filters
    $full_width = $data['wpss_fullwidth'] ;
    $half_width = $data['wpss_halfwidth'];
    $image_height = $data['wpss_height'];

    /*
     * Set Some args and run a WP Query
     */
    $slide_args = array(
        'post_type' => 'wpss_slides',
        'posts_per_page' => -1, 'post_status' => 'publish',
        'tax_query' => array(
            array(
                'taxonomy' => 'wpss_sliders',
                'field'   => 'slug',
                'terms'     => $slider
            )
        )
    );

    $slides = new WP_Query( $slide_args );
    
    /*
     * Let The Party Begin!
     */
    if($slides -> have_posts()):

    $out = '<div class="wpss_slideshow" id="wpss_slideshow_' . $slider . '">';

        $out .= '<div class="wpss_slideshow_">';

            
            while($slides -> have_posts()): $slides-> the_post();

            $out .= '<div id="slide-' . $post->ID . '" class="wpss_slide">';
            
            $type = get_post_meta($post->ID , 'Slide Type' , true);

            switch ( $type ){

                case 'Full Width Image':

                    //Get The ID of the post thumbnail
                    $img_id = get_post_thumbnail_id( $post->ID );

                    //Then pull the source of the fullsize image
                    $imgsrc = wp_get_attachment_image_src( $img_id , 'full' );
                    $imgsrc = $imgsrc[0];

                    //Get the image from timthumb.
                    $img = '<img src="' . $timthumbsrc . '?src=' . $imgsrc . '&w=' . $full_width . '&h=' . $image_height . '" alt="" />';
                    //$img = get_the_post_thumbnail($post->ID, 'wpps_full' );

                    $out .= '<div class="wpss_img full">';
                    $out .= $img;
                    $out .= '</div>';

                    break;

                case 'Left Half Image':

                    //Get The ID of the post thumbnail
                    $img_id = get_post_thumbnail_id( $post->ID );

                    //Then pull the source of the fullsize image
                    $imgsrc = wp_get_attachment_image_src( $img_id , 'full' );
                    $imgsrc = $imgsrc[0];

                    //Get the image from timthumb.
                    $img = '<img src="' . $timthumbsrc . '?src=' . $imgsrc . '&w=' . $half_width . '&h=' . $image_height . '" alt="" />';

                    $out .= '<div class="wpss_img half">';
                    $out .= $img;
                    $out .= '</div>';

                    $out .= '<div class="wpss_content_half">';
                    $out .= '<h4>' . get_the_title() . '</h4>';
                    $out .= apply_filters( 'the_content' , get_the_content() ) ;
                    $out .= '</div>';

                    break;

                case 'Right Half Image':

                   //Get The ID of the post thumbnail
                    $img_id = get_post_thumbnail_id( $post->ID );

                    //Then pull the source of the fullsize image
                    $imgsrc = wp_get_attachment_image_src( $img_id , 'full' );
                    $imgsrc = $imgsrc[0];

                    //Get the image from timthumb.
                    $img = '<img src="' . $timthumbsrc . '?src=' . $imgsrc . '&w=' . $half_width . '&h=' . $image_height . '" alt="" />';

                    $out .= '<div class="wpss_content_half">';
                    $out .= '<h4>' . get_the_title() . '</h4>';
                    $out .= apply_filters( 'the_content' , get_the_content() ) ;
                    $out .= '</div>';

                    $out .= '<div class="wpss_img half">';
                    $out .= $img;
                    $out .= '</div>';

                    break;

                case 'Full Width Text':

                    $out .= '<div class="wpss_content_full">';
                    $out .= '<h4>' . get_the_title() . '</h4>';
                    $out .= apply_filters( 'the_content' , get_the_content() ) ;
                    $out .= '</div>';

                    break;

                default:

                    $out .= '<!-- WP Slick Slider Has Not Been Configured Correctly -->';

                    break;

            }

            $out .= '</div>'; //End Slide


            endwhile; 

        $out .= '</div>';

        $out .= '<div id="wpss_slideshow_pager_' . $slider . '"></div>';
        
    $out .= '</div><!--end WP Slick Slider slideshow-->';

    else:

    $out .= '<!-- No Slides Are In The Selected Slider Or The Slider Selected Has Been Incorrectly Named. -->';

    endif; wp_reset_query();

    if( ! $echo )
        return $out;

    echo $out;
    
}


/*
 * Shortcode
 */
function sc_wpss( $atts ){
    extract($atts);

    if( ! isset( $name ) ){
        $name = false;
    }
    
    return wp_slick_slider( $name,  false );
    
}
add_shortcode( 'SlickSlider' , 'sc_wpss' );

?>